/***
* OOP.PRG file
*
* Testing Speed with FirstClass
*
* (c) 1994 Grupo EIDOS
*
* Alfonso Fraguas
* Antonio Rojo
*/
//
#include "1STCLASS.CH"

// #xcommand > <x> [,<n>] => FWrite(1, Chr(13) + Chr(10) + <x> [ + <n> ])

// Use this option if you want to redirect both outputs to the screen and
// printer
#xcommand > <x> [,<n>] => FWrite(1, Chr(13) + Chr(10) + <x> [ + <n> ]) ;;
                             QOut( <x> [, <n> ] )

FUNCTION Start( xVal )
   LOCAL nTotal := Seconds()
   LOCAL j
   LOCAL f
   LOCAL nSec
   LOCAL nTime
   LOCAL pp1      := Una():New()
   LOCAL nVal
   LOCAL oGeneric0
   LOCAL oGeneric1
   LOCAL oGeneric2
   LOCAL oGeneric3
   LOCAL oGeneric4
   LOCAL oGeneric5
   LOCAL oGeneric6
   LOCAL oGeneric7
   LOCAL oGeneric8

   CLS
   nVal := Val(xVal)


   > "Every test has been exec. ", xVal, " Times"
   > ""
   > "First Class 2.0                                FOR      NO FOR"
   > ""
   > ""
   > "Please wait..."

   // Calculating the FOR timing to discount it later
   nSec := Seconds()
   FOR f := 1 TO nVal
   NEXT f
   nTime := Seconds() - nSec

   // Test 01 --------------------------------------------------
   nSec := Seconds()
   FOR f := 1 TO nVal
      j := pp1:uno
   NEXT f
   nSec := Seconds() - nSec
   > '01.- Access to a VISIBLE variable.....: ', ;
     Str(nSec,10,4), Str(nSec-nTime,10,4)

   // Test 02 --------------------------------------------------
   nSec := Seconds()
   FOR f := 1 TO nVal
      pp1:uno := 1
   NEXT f
   nSec := Seconds() - nSec
   > '02.- Asign a VISIBLE variable.........: ', ;
     Str(nSec,10,4), Str(nSec-nTime,10,4)

   // Test 03 --------------------------------------------------
   nSec := Seconds()
   FOR f := 1 TO nVal
      j := pp1:ClassVar
   NEXT f
   nSec := Seconds() - nSec
   > '03.- Access to a CLASS VAR value......: ', ;
     Str(nSec,10,4), Str(nSec-nTime,10,4)

   // Test 04 --------------------------------------------------
   nSec := Seconds()
   FOR f := 1 TO nVal
      pp1:ClassVar := 1
   NEXT f
   nSec := Seconds() - nSec
   > '04.- Asign value to a CLASS VAR.......: ', ;
     Str(nSec,10,4), Str(nSec-nTime,10,4)

   // Test 05 --------------------------------------------------
   nSec := Seconds()
   FOR f := 1 TO nVal
      pp1:Vacio()
   NEXT f
   nSec := Seconds() - nSec
   > '05.- Execute an empty method..........: ', ;
     Str(nSec,10,4), Str(nSec-nTime,10,4)

   // Test 06 --------------------------------------------------
   nSec := Seconds()
   FOR f := 1 TO nVal
      pp1:As()
   NEXT f
   nSec := Seconds() - nSec
   > '06.- Execute a method with asignation.: ', ;
     Str(nSec,10,4), Str(nSec-nTime,10,4)

   // Test 07 --------------------------------------------------
   nSec := Seconds()
   FOR f := 1 TO nVal
      Una():New()
   NEXT f
   nSec := Seconds() - nSec
   > '07.- Create initialized objects.......: ', ;
     Str(nSec,10,4), Str(nSec-nTime,10,4)

   // Test 08 --------------------------------------------------
   nSec := Seconds()
   FOR f := 1 TO nVal
      pp1:Padre()
   NEXT f
   nSec := Seconds() - nSec
   > '08.- Execute a method with parent.....: ', ;
     Str(nSec,10,4), Str(nSec-nTime,10,4)

   // Test 09 --------------------------------------------------
   nSec := Seconds()
   FOR f := 1 TO nVal
      pp1:AccHid()
   NEXT f
   nSec := Seconds() - nSec
   > '09.- Method with HIDDEN access........: ', ;
     Str(nSec,10,4), Str(nSec-nTime,10,4)

   // Test 10 --------------------------------------------------
   nSec := Seconds()
   FOR f := 1 TO nVal
      pp1:AsgHid()
   NEXT f
   nSec := Seconds() - nSec
   > '10.- Method with HIDDEN asign.........: ', ;
     Str(nSec,10,4), Str(nSec-nTime,10,4)

   // Test 11 --------------------------------------------------
   nSec := Seconds()
   FOR f := 1 TO nVal
      pp1:Padre2()
   NEXT f
   nSec := Seconds() - nSec
   > '11.- Executing QParent( STATIC )......: ', ;
     Str(nSec,10,4), Str(nSec-nTime,10,4)

   // Test 12 --------------------------------------------------
   nSec := Seconds()
   FOR f := 1 TO nVal
      oGeneric0 := Una():New()
      oGeneric1 := Cuatro():New()
      oGeneric2 := Dos():New()
      oGeneric3 := Una():New()
      oGeneric4 := Tres():New()
      oGeneric5 := Una():New()
      oGeneric6 := Una():New()
      oGeneric7 := Cinco():New()
      oGeneric8 := Seis():New()
   NEXT f
   nSec := Seconds() - nSec
   > '12.- Creating 8 Objects...............: ', ;
     Str(nSec,10,4), Str(nSec-nTime,10,4)

   // Global Notes ---------------------------------------------
   > ""
   > "Memory State"
   > ""
   > "Memory(0)", Str( Memory(0) )
   > "Memory(1)", Str( Memory(1) )
   > "Memory(2)", Str( Memory(2) )
   > "Memory(3)", Str( Memory(3) )
   > "Memory(4)", Str( Memory(4) )
   > ''
   > 'Total time............................: ', ;
     Str(Seconds()-nTotal,10,4)

   > 'Press any key to finish'
   InKey(0)
   CLS

RETURN NIL

// -
CREATE CLASS Una FROM Dos
   PROTECTED:
      VAR Tres1
      VAR Tres2
      VAR Tres3
      VAR Tres4

   VISIBLE:
      VAR uno
      CLASS VAR ClassVar

      METHOD Vacio
      METHOD As
      METHOD Init
      METHOD Padre
      METHOD Padre2
      METHOD AccHid
      METHOD AsgHid
ENDCLASS

//
METHOD AccHid()
RETURN ::Tres1

//
METHOD AsgHid()
   ::Tres1 := 1
   ::Tres2 := 1
   ::Tres3 := 1
   ::Tres4 := 1
RETURN Self

//
METHOD Vacio()
RETURN NIL

//
METHOD As()
   ::Uno := 1
RETURN NIL

//
METHOD Init()
RETURN Self

//
METHOD Padre()
   ::Super:Check()
RETURN NIL

//
METHOD Padre2()
   STATIC k
   ::QParent( k ):Check()
RETURN NIL

// -
INITIALIZE CLASS

CREATE CLASS Dos FROM Tres
   VISIBLE:
      VAR Dos
      METHOD Check
ENDCLASS

//
METHOD Check()
RETURN NIL

// -

INITIALIZE CLASS

CREATE CLASS Tres FROM Cuatro
ENDCLASS

// -

INITIALIZE CLASS

CREATE CLASS Cuatro FROM Cinco
ENDCLASS

// -

INITIALIZE CLASS

CREATE CLASS Cinco FROM Seis
ENDCLASS

// -

INITIALIZE CLASS

CREATE CLASS Seis
   VISIBLE:
      VAR SixUno
      VAR SixDos
      VAR SixTres
      VAR SixCuatro
      VAR SixCinco
      VAR SixSeis
      VAR SixSiete
      VAR SixOcho
      VAR SixNueve
      VAR SixDiez
      VAR SixOnce
      VAR SixDoce
      VAR SixTrece
      VAR SixCatorce
      VAR SixQuince
      VAR SixDieciseis
      VAR SixDiecisiete
      VAR SixDieciocho
      VAR SixDiecinueve
      VAR SixVeinte
ENDCLASS